#version 440
layout(location = 0) in vec2 qt_TexCoord0;
layout(location = 0) out vec4 fragColor;
layout(std140, binding = 0) uniform buf {
    mat4 qt_Matrix;
    float qt_Opacity;
    vec2 size;
    float radius;
};
layout(binding = 1) uniform sampler2D source;

void main() {
    vec2 pixPos = qt_TexCoord0 * size;
    vec2 center = size * 0.5;
    vec2 corner = vec2(radius);
    vec2 topLeft = corner;
    vec2 topRight = vec2(size.x - corner.x, corner.y);
    vec2 bottomLeft = vec2(corner.x, size.y - corner.y);
    vec2 bottomRight = size - corner;
    
    float dist = 0.0;
    if (pixPos.x < corner.x && pixPos.y < corner.y)
        dist = distance(pixPos, topLeft);
    else if (pixPos.x > size.x - corner.x && pixPos.y < corner.y)
        dist = distance(pixPos, topRight);
    else if (pixPos.x < corner.x && pixPos.y > size.y - corner.y)
        dist = distance(pixPos, bottomLeft);
    else if (pixPos.x > size.x - corner.x && pixPos.y > size.y - corner.y)
        dist = distance(pixPos, bottomRight);
    
    vec4 color = texture(source, qt_TexCoord0);
    fragColor = dist > radius ? vec4(0) : color;
}