//@ pragma UseQApplication
//@ pragma NativeTextRendering

import Quickshell
import Quickshell.Io

ShellRoot {
    id: root
    
    FileView {
        id: configFile
        path: Qt.resolvedUrl(Quickshell.env("HOME")+"/.config/pikabar/config.json")
        blockLoading: true
    }

    readonly property var config: {
        try {
            return JSON.parse(configFile.text()) || {
                weather: {
                    isamerican: false,
                    city: "London",
                    weatherupdateinterval: 900
                },
				workspaces: 10,
                sysinfoupdateinterval: "2s"
            }
        } catch (e) {
            console.error("Failed to parse config:", e)
            return {
                weather: {
                    isamerican: false,
                    city: "London",
                    weatherupdateinterval: 900
                },
				workspaces: 10,
                sysinfoupdateinterval: "2s"
            }
        }
    }

    Variants {
        model: Quickshell.screens

        Topbar {
            required property var modelData
            weatherConfig: root.config.weather || {}
            sysInfoInterval: root.config.sysinfoupdateinterval
			workspaces: root.config.workspaces
            screen: modelData
        }
    }
}