import QtQuick
import QtQuick.Layouts
import Quickshell
import Quickshell.Wayland
import Quickshell.Widgets
import "root:/"

Row {
    spacing: 10

    function getIcon() {
        var icon = Quickshell.iconPath(ToplevelManager.activeToplevel.appId.toLowerCase(), true);
        if (!icon) {
            icon = Quickshell.iconPath(ToplevelManager.activeToplevel.appId, true);
        }
        if (!icon) {
            icon = Quickshell.iconPath(ToplevelManager.activeToplevel.title, true);
        }
        if (!icon) {
            icon = Quickshell.iconPath(ToplevelManager.activeToplevel.title.toLowerCase(), "application-x-executable");
        }

        return icon;
    }

    IconImage {
        height: 42
        Layout.fillHeight: true
        implicitWidth: parent.height * 0.6
        source: ToplevelManager.activeToplevel ? getIcon() : ""
    }

    Text {
        id: text
        height: 42
        text: ToplevelManager.activeToplevel?.title ?? ""
        color: Globals.commonStyles.textColor
        font.pointSize: Globals.commonStyles.smallTextFontSize
        font.family: Globals.commonStyles.fontFamily
        font.weight: Globals.commonStyles.fontWeight
        elide: Text.ElideRight
        width: Math.min(implicitWidth, 200)
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
    }
}
