import QtQuick

Rectangle {
    id: root
    property real padding: 6
    // all items placed inside the BarWidget will go to the content item
    default property alias data: content.data

    // can be used to override implicit size if needed
    property alias widgetImplicitHeight: content.implicitHeight
    property alias widgetImplicitWidth: content.implicitWidth

    property alias widgetAnchors: content.anchors

    implicitWidth: content.implicitWidth + widgetAnchors.leftMargin + widgetAnchors.rightMargin
    implicitHeight: content.implicitHeight + widgetAnchors.topMargin + widgetAnchors.bottomMargin

    Item {
        id: content
        anchors.fill: parent
        anchors.margins: root.padding

        implicitWidth: children[0]?.implicitWidth ?? 0
        implicitHeight: children[0]?.implicitHeight ?? 0
    }
}
