import QtQuick
import Quickshell
import Quickshell.Widgets

MouseArea {
    id: root
    property string icon
    property bool enabled: true
    property bool highlight: false

    property real size: 16

    implicitWidth: size
    implicitHeight: size

    Rectangle {
        anchors.fill: parent
        radius: 5
        color: highlight ? "#35ffffff" : "transparent"
    }

    IconImage {
        anchors.centerIn: parent
        source: Quickshell.iconPath(root.icon)
        implicitSize: root.size

        opacity: root.enabled ? 1.0 : 0.5
    }
}
